from bs4 import BeautifulSoup

from selenium import webdriver
from selenium.webdriver.support.ui import WebDriverWait
from selenium.webdriver.support import expected_conditions as EC
from selenium.webdriver.common.by import By
from selenium.webdriver.chrome.options import Options

from Queue import Queue
from threading import Thread

import sys
import os
import random
import requests
import urllib2
import urllib


import subprocess
import time



def saveImage(image, name, mainPath):
    '''
        Saves the 'image' in the specified 'path/name' as 'name'_i, where i stands for
        the number of images contained in that directory plus one. If 'path/name' does
        not exist it will be created.
    '''



    idx = len([i for i in os.listdir(mainPath) if name in i]) + 1

    nameToSave = name + '_' + str(idx)

    f = open(os.path.join(mainPath, nameToSave), 'wb')

    try:
        f.write(urllib.urlopen(image).read())
        f.close()

        urlsFile = open(os.path.join(mainPath, name+'.txt'), 'a')
        urlsFile.write(nameToSave + ":" + image+"\n")
        urlsFile.close()

        return nameToSave

    except:
        print "Could not save %s" % nameToSave
        f.close()
        #os.remove(os.path.join(mainPath, nameToSave))
        return None

def intentar(driver):
    
    driver.find_element_by_css_selector('.ksb._kvc').click()
    time.sleep(2)
    try:
        WebDriverWait(driver, 10).until(lambda driver : driver.find_element(By.ID, 'irc_cc').is_displayed())
    except TimeOutException:
        driver.close()



def getImage(driver, URL, imageName, urlBase, pathToSave="images"):


    imageURLs = []
    #driver = webdriver.Chrome("C:\Program Files (x86)\Google\Chrome\chromedriver.exe")
    #driver = webdriver.Chrome('/media/HDD_2TB/marc/chromedriver64')  # Optional argument, if not specified will search path.

    #driver = webdriver.Chrome()


    driver.get(URL)
    


    src = driver.page_source

    parser = BeautifulSoup(src, "html.parser")



    links = []
    # We get the three
    for a in parser.findAll("a", {"class" : "irc_fsl irc_but i3596"}):
        try:

            link = a.get('href')
            if link:
                links.append(link)

        except:
            pass
    


    driver.get(urlBase)
    time.sleep(0.3)
    #driver.close()
    return links








def getRandomAgent():
    '''
        Returns a random User-Agent.
    '''

    userAgents = [
        {"User-Agent": "Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/36.0.1985.125 Safari/537.36"},
        {"User-Agent": "Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/33.0.1750.149 Safari/537.36"},
        {"User-Agent": "Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:40.0) Gecko/20100101 Firefox/40.0" },
        {"User-Agent": "Mozilla/5.0 (Windows NT 6.3; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.85 Safari/537.36" },
        {"User-Agent": "Mozilla/5.0 (Windows NT 6.1; WOW64; rv:39.0) Gecko/20100101 Firefox/39.0" }
    ]

    return userAgents[random.randint(0, len(userAgents)-1)]


class DownloadWorker(Thread):
    def __init__(self, queue):
        Thread.__init__(self)
        self.queue = queue

    def run(self):
        while True:
            link, imageName, mainPath = self.queue.get()
            saveImage(link, imageName, mainPath)
            self.queue.task_done()


class LinkWorker(Thread):
    def __init__(self, driver, urlBase, queueQ, queueR, newDriver):
        Thread.__init__(self)
        self.queueQ = queueQ
        self.queueR = queueR
        self.driver = driver
        self.urlBase = urlBase
        if newDriver:
            scrollUntilEnd(self.driver, self.urlBase)



    def run(self):
        while True:
            driver, urls, queryName, urlBase = self.queueQ.get()
            links = goOverImages(driver, urls, queryName, urlBase)
            self.queueR.put((links))
            self.queueQ.task_done()




def goOverImages(driver, urls, queryName, urlBase):
    allLinks = []
    i = 1
    for url in urls:
        if i%3==2:
            links = []
            links = getImage(driver, url, queryName, urlBase)

            for l in links:
                allLinks.append(l)
        i+=1


    

    return allLinks



def goToDownloadImage(driver, URLs, queryName, urlBase):

    start_time = time.time()

    allLinks = []
    
    i=1




    queueResponse = Queue()
    queueQuery = Queue()

    queueQuery.put((driver, URLs, queryName, urlBase))
    linkWorker = LinkWorker(driver, urlBase, queueQuery, queueResponse, False)
    linkWorker.daemon = True
    linkWorker.start()


    queueQuery.join()
    
    


    if queueQuery.unfinished_tasks:
        print "Mal, se llego a timeout"
        return -1

    else:
        print "Todo bien, all tasks finished"




    allLinks = queueResponse.get()
    print "Number of images IDs" + str(len(allLinks))
    
    print("--- %s seconds --- to get Images IDs" % (time.time() - start_time))
    
    start_time = time.time()

    path = 'googleImages'
    mainPath = os.path.join(path, queryName)

    # create new path if necessary
    if not os.path.exists(mainPath):
        os.makedirs(mainPath)

    
    stop2 = time.time()+330    
    

    queue = Queue()
    for x in range(4):
        worker = DownloadWorker(queue)
        worker.daemon = True
        worker.start()  


    numDoubles = 0
    for link in allLinks:
        if allLinks.count(link)>1:
            file = open(os.path.join(mainPath, "doubledLinks.txt"), 'a')
            file.write(link + "\n")
            file.close()
            numDoubles+=1
        queue.put((link, queryName, mainPath))
 
    #queue.join()
    while queue.unfinished_tasks and time.time()<stop2:
        a=1

    if queue.unfinished_tasks:
        print "Some download alive"
    else:
        print "All downloads OK"

    print("--- %s seconds --- to download Images" % (time.time() - start_time))

    print(str(numDoubles/2) + " Double images.")



def scrollUntilEnd(driver, url):
    driver.get(url)

    scrollDown(driver)
    

    #WebDriverWait(driver, 10).until(EC.visibility_of_element_located((By.CLASS_NAME, 'ksb _kvc')))
    
    time.sleep(3)
    #driver.find_element_by_css_selector('.ksb._kvc').click()

    if (EC.visibility_of_element_located((By.CLASS_NAME, 'ksb _kvc'))):
        try:
            driver.find_element_by_css_selector('.ksb._kvc').click()
        except:
            print "Cannot click button to load more images"
            f = open("notCompletedClasses.txt", "a")
            f.write(imageName + "\n")
            f.close()            
            
            


    #if (driver.find_element_by_css_selector('.ksb._kvc')):
        #driver.find_element_by_css_selector('.ksb._kvc').click()

    time.sleep(1)
    scrollDown(driver)



def scrollDown(driver):
    wantScroll = True
    lastHeight = driver.execute_script("return document.body.scrollHeight")
    while wantScroll:
        driver.execute_script("window.scrollTo(0, document.body.scrollHeight);")
        #driver.execute_script("window.scrollTo(0,0);")
        time.sleep(3)
        newHeight = driver.execute_script("return document.body.scrollHeight")
        if newHeight == lastHeight:
            wantScroll=False
        lastHeight = newHeight

    


def getImageIds(driver, URL, query, session):
    ''' 
        Requests google for image URLs related to 'query' and returns them.
    '''

    imageIds = []
    width = 1366
    height = 768

    params = {
        "q": query,
        "sa": "X",
        "biw": width,
        "bih": height,
        "tbm": "isch",
    }

    request = session.get(URL, params=params)


    url = request.url

    #driver =  webdriver.Chrome("C:\Program Files (x86)\Google\Chrome\chromedriver.exe")
    #driver = webdriver.Chrome('/media/HDD_2TB/marc/chromedriver64')

    driver.get(url)

    scrollDown(driver)
    

    #WebDriverWait(driver, 10).until(EC.visibility_of_element_located((By.CLASS_NAME, 'ksb _kvc')))
    
    time.sleep(3)
    #driver.find_element_by_css_selector('.ksb._kvc').click()

    if (EC.visibility_of_element_located((By.CLASS_NAME, 'ksb _kvc'))):
        try:
            driver.find_element_by_css_selector('.ksb._kvc').click()
        except:
            print "Cannot click button to load more images"
            f = open("notCompletedClasses.txt", "a")
            f.write(imageName + "\n")
            f.close()         

    #if (driver.find_element_by_css_selector('.ksb._kvc')):
        #driver.find_element_by_css_selector('.ksb._kvc').click()

    time.sleep(1)
    scrollDown(driver)

    time.sleep(2)

    src = driver.page_source

    #driver.close()
    parser = BeautifulSoup(src, "html.parser")

    imageIds=[]

    for img in parser.findAll("div", {"class": "rg_el"}):
        try:
            # We obtain image id
            idImage = img.find("img").attrs["name"]
            # Work with this id to make it usable
            imageIds.append(request.url+"#imgrc="+idImage[:len(idImage)-1]+"%3A")
        except:
            pass


    imageIds.insert(0, request.url + "#imgrc=_")
    return imageIds




def getImages(imageName, pathToSave="images"):
    '''
        Downloads as much as 1000 pictures related to the google query 'imageName' and saves
        them inside 'pathToSave/imageName'.

        args:
            imageName: image data to search for
            pathToSave: root path where the images will be saved (e.g.: pathToSave/imageName/imageName_i.jpg)

        return: a list of the downloaded image pair [URL, name]
    '''

    URL = "https://www.google.com/search"

    s = requests.session()

    chrome_options = Options()

    chrome_options.add_argument("--no-sandbox")

    driver = webdriver.Chrome(chrome_options = chrome_options)
    
    T = getImageIds(driver, URL, imageName, s)
    urlBase = T[0]

    urls = T[1:]
    
    print T[0]
    print len(urls)

    result = goToDownloadImage(driver, urls, imageName, urlBase)
    if result==-1:
        #Problems with this class
        f = open("noDownloadedClasses.txt", "a")
        f.write(imageName + "\n")
        f.close()
    driver.close()

if __name__ == "__main__":

    import sys

    getImages(" ".join(sys.argv[1:]))
