import matplotlib.pyplot as plt
import sys

if len(sys.argv) == 3:
	filename = sys.argv[1]
	iter_size = int(sys.argv[2])
	x = []
	y_acc_train = []
	y_loss_train = []

	y_acc_val = []
	y_loss_val = []

	with open(filename) as f:
		i = 0
		for line in f.readlines():
			if i > 1:
				l = line.split(',')
				# In log, net 0 is train
				if i%2 == 0:
					x.append(float(l[0]))
					y_acc_train.append(float(l[3]))
					y_loss_train.append(float(l[4]))
				elif i%2 != 0:
					y_acc_val.append(float(l[3]))
					y_loss_val.append(float(l[4]))
			i += 1

	print y_loss_val
	print len(y_loss_val)
	
	x = [i/iter_size for i in x]
	fig = plt.figure()

	ax = fig.add_subplot(1,1,1)
	lns1 = ax.plot(x,y_acc_train,'-c',label='acc_train')
	lns2 = ax.plot(x,y_acc_val,'-b',label='acc_val')
	
	ax2 = ax.twinx()
	lns3 = ax2.plot(x,y_loss_train,'-r',label='loss_train')
	lns4 = ax2.plot(x,y_loss_val,'-y',label='loss_val')
	ax.grid()
	ax.set_ylabel('acc')
	ax2.set_ylabel('loss')

	ax.set_ylim(ymin=0)
	#ax2.set_ylim(ymin=0)

	# added these three lines
	lns = lns1+lns2+lns3+lns4
	labs = [l.get_label() for l in lns]
	ax.legend(lns, labs, loc='upper center',ncol=4,bbox_to_anchor=(0.5, 1.10))

	plt.show()

